var test = require('tap').test
var npmconf = require('../npmconf.js')
var fs = require('fs')
var ini = require('ini')
var conf = __dirname + '/fixtures/userconfig-reg'

var expectFile =
  [ 'email = foo@bar.com',
    'user-agent = drftgyhujikol',
    'foobar = 123',
    '',
    '[registries."http://blah.blah/"]',
    'email = blah@bar.com',
    'user-agent = blahblahblah',
    '',
    '[registries."http://registry.foo.bar/"]',
    'bazquux = 456',
    '' ].join('\n')

test('saving to new registry', function (t) {
  npmconf.load({
    userconfig: conf,
    registry: 'http://registry.foo.bar/'
  }, function (er, conf) {
    if (er)
      throw er
    t.equal(conf.get('email'), 'foo@bar.com')
    conf.set('foobar', '123', 'user')
    conf.set('bazquux', '456', 'user-reg')
    t.equal(conf.get('foobar'), '123')
    t.equal(conf.get('bazquux'), '456')

    var uc = fs.readFileSync(conf.get('userconfig'), 'utf8')
    conf.save('user', function (er) {
      try {
        var uc2 = fs.readFileSync(conf.get('userconfig'), 'utf8')
      } finally {
        fs.writeFileSync(conf.get('userconfig'), uc, 'utf8')
      }
      if (er)
        throw er
      t.same(ini.parse(uc2), ini.parse(expectFile))
      t.end()
    })
  })
})

